//
//  GetOpt.m
//
//  This file is a part of librabbitmq-objc-examples
//
//  Copyright © 2012 Jani Hur <http://www.jani-hur.net>
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#import "GetOpt.h"

@implementation GetOpt
{
    NSArray* options;
}

-(id)init {
    if(self = [super init]) {
        options = [[NSProcessInfo processInfo] arguments];
    }
    return self;
}

-(NSString*)description {
    NSMutableString* str = [[NSMutableString alloc]init];
    Boolean skipFirst = true;
    for (NSString* opt in options) {
        if (skipFirst) {
            skipFirst = false;
            continue;
        }
        [str appendString:opt];
        [str appendString:@" "];
    }
    // TODO trim the last whitespace
    return str;
}

-(NSString*)getStringOf:(NSString*)option {
    NSInteger index = [options indexOfObject:option];
    @try {
        return [options objectAtIndex:index + 1];
    }
    @catch (NSException *exception) {
        NSString* reason = [[NSString alloc] initWithFormat:@"Mandatory option %@ missing", option];
        @throw [NSException exceptionWithName:@"AMQPGetOptException" reason:reason userInfo:nil];
    }
}
-(NSString*)getStringOf:(NSString*)option defaultValue:(NSString*)defaultValue {
    NSInteger index = [options indexOfObject:option];
    @try {
        return [options objectAtIndex:index + 1];
    }
    @catch (NSException *exception) {
        return defaultValue;
    }
}

@end
