//
//  main.m
//
//  This file is a part of librabbitmq-objc-examples
//
//  Copyright © 2012 Jani Hur <http://www.jani-hur.net>
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#import <Foundation/Foundation.h>

#import "AMQPConnection.h"
#import "AMQPExchange.h"

#import "GetOpt.h"

int main(int argc, const char * argv[])
{

    @autoreleasepool {

        GetOpt* opts = [[GetOpt alloc]init];
        NSLog(@"opts = %@", opts);
        
        NSString* host = [opts getStringOf:@"-h"];
        NSString* routingkey = [opts getStringOf:@"-r"];
        NSString* message = [opts getStringOf:@"-m"];

        AMQPConnection* connection = [[AMQPConnection alloc] init];
        
        [connection connectToHost:host];
        [connection login];
        
        AMQPChannel* channel = [connection openChannel];
        
        AMQPExchange* exchange = [[AMQPExchange alloc] initWithName:@"" onChannel:channel];
        
        amqp_basic_properties_t props;
        props._flags = AMQP_BASIC_CONTENT_TYPE_FLAG | AMQP_BASIC_DELIVERY_MODE_FLAG;
        props.content_type = amqp_cstring_bytes("text/plain");
        props.delivery_mode = AMQP_PERSISTENT_DELIVERY_MODE;
        
        [exchange publishMessage:message usingRoutingKey:routingkey usingProperties:&props];
    }
    return 0;
}

